/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUBufferUsage.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "GPUBufferUsage.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotCallable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/ObjectPrototype.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>

namespace WebCore {
using namespace JSC;

using JSGPUBufferUsageDOMConstructor = JSDOMConstructorNotCallable<JSGPUBufferUsage>;

/* Hash table for constructor */

static const std::array<HashTableValue, 10> JSGPUBufferUsageConstructorTableValues {
    HashTableValue { "MAP_READ"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0001 } },
    HashTableValue { "MAP_WRITE"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0002 } },
    HashTableValue { "COPY_SRC"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0004 } },
    HashTableValue { "COPY_DST"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0008 } },
    HashTableValue { "INDEX"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0010 } },
    HashTableValue { "VERTEX"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0020 } },
    HashTableValue { "UNIFORM"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0040 } },
    HashTableValue { "STORAGE"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0080 } },
    HashTableValue { "INDIRECT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0100 } },
    HashTableValue { "QUERY_RESOLVE"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x0200 } },
};

static_assert(GPUBufferUsage::MAP_READ == 0x0001, "MAP_READ in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::MAP_WRITE == 0x0002, "MAP_WRITE in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::COPY_SRC == 0x0004, "COPY_SRC in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::COPY_DST == 0x0008, "COPY_DST in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::INDEX == 0x0010, "INDEX in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::VERTEX == 0x0020, "VERTEX in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::UNIFORM == 0x0040, "UNIFORM in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::STORAGE == 0x0080, "STORAGE in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::INDIRECT == 0x0100, "INDIRECT in GPUBufferUsage does not match value from IDL");
static_assert(GPUBufferUsage::QUERY_RESOLVE == 0x0200, "QUERY_RESOLVE in GPUBufferUsage does not match value from IDL");

template<> const ClassInfo JSGPUBufferUsageDOMConstructor::s_info = { "GPUBufferUsage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUBufferUsageDOMConstructor) };

template<> JSValue JSGPUBufferUsageDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.objectPrototype();
}

template<> void JSGPUBufferUsageDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
    reifyStaticProperties(vm, JSGPUBufferUsage::info(), JSGPUBufferUsageConstructorTableValues, *this);
    UNUSED_PARAM(globalObject);
}

const ClassInfo JSGPUBufferUsage::s_info = { "GPUBufferUsage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUBufferUsage) };

JSGPUBufferUsage::JSGPUBufferUsage(Structure* structure, JSDOMGlobalObject& globalObject)
    : JSDOMObject(structure, globalObject) { }

static_assert(!std::is_base_of<ActiveDOMObject, GPUBufferUsage>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSValue JSGPUBufferUsage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUBufferUsageDOMConstructor, DOMConstructorID::GPUBufferUsage>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUBufferUsage::destroy(JSC::JSCell* cell)
{
    JSGPUBufferUsage* thisObject = static_cast<JSGPUBufferUsage*>(cell);
    thisObject->JSGPUBufferUsage::~JSGPUBufferUsage();
}

JSC::GCClient::IsoSubspace* JSGPUBufferUsage::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSGPUBufferUsage, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForGPUBufferUsage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForGPUBufferUsage = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForGPUBufferUsage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForGPUBufferUsage = std::forward<decltype(space)>(space); }
    );
}


}
