/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUColorWrite.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "GPUColorWrite.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotCallable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/ObjectPrototype.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>

namespace WebCore {
using namespace JSC;

using JSGPUColorWriteDOMConstructor = JSDOMConstructorNotCallable<JSGPUColorWrite>;

/* Hash table for constructor */

static const std::array<HashTableValue, 5> JSGPUColorWriteConstructorTableValues {
    HashTableValue { "RED"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x1 } },
    HashTableValue { "GREEN"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x2 } },
    HashTableValue { "BLUE"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x4 } },
    HashTableValue { "ALPHA"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8 } },
    HashTableValue { "ALL"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0xF } },
};

static_assert(GPUColorWrite::RED == 0x1, "RED in GPUColorWrite does not match value from IDL");
static_assert(GPUColorWrite::GREEN == 0x2, "GREEN in GPUColorWrite does not match value from IDL");
static_assert(GPUColorWrite::BLUE == 0x4, "BLUE in GPUColorWrite does not match value from IDL");
static_assert(GPUColorWrite::ALPHA == 0x8, "ALPHA in GPUColorWrite does not match value from IDL");
static_assert(GPUColorWrite::ALL == 0xF, "ALL in GPUColorWrite does not match value from IDL");

template<> const ClassInfo JSGPUColorWriteDOMConstructor::s_info = { "GPUColorWrite"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUColorWriteDOMConstructor) };

template<> JSValue JSGPUColorWriteDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.objectPrototype();
}

template<> void JSGPUColorWriteDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
    reifyStaticProperties(vm, JSGPUColorWrite::info(), JSGPUColorWriteConstructorTableValues, *this);
    UNUSED_PARAM(globalObject);
}

const ClassInfo JSGPUColorWrite::s_info = { "GPUColorWrite"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUColorWrite) };

JSGPUColorWrite::JSGPUColorWrite(Structure* structure, JSDOMGlobalObject& globalObject)
    : JSDOMObject(structure, globalObject) { }

static_assert(!std::is_base_of<ActiveDOMObject, GPUColorWrite>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSValue JSGPUColorWrite::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUColorWriteDOMConstructor, DOMConstructorID::GPUColorWrite>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUColorWrite::destroy(JSC::JSCell* cell)
{
    JSGPUColorWrite* thisObject = static_cast<JSGPUColorWrite*>(cell);
    thisObject->JSGPUColorWrite::~JSGPUColorWrite();
}

JSC::GCClient::IsoSubspace* JSGPUColorWrite::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSGPUColorWrite, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForGPUColorWrite.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForGPUColorWrite = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForGPUColorWrite.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForGPUColorWrite = std::forward<decltype(space)>(space); }
    );
}


}
