/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUTextureUsage.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "GPUTextureUsage.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotCallable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMWrapperCache.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/ObjectPrototype.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>

namespace WebCore {
using namespace JSC;

using JSGPUTextureUsageDOMConstructor = JSDOMConstructorNotCallable<JSGPUTextureUsage>;

/* Hash table for constructor */

static const std::array<HashTableValue, 5> JSGPUTextureUsageConstructorTableValues {
    HashTableValue { "COPY_SRC"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x01 } },
    HashTableValue { "COPY_DST"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x02 } },
    HashTableValue { "TEXTURE_BINDING"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x04 } },
    HashTableValue { "STORAGE_BINDING"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x08 } },
    HashTableValue { "RENDER_ATTACHMENT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x10 } },
};

static_assert(GPUTextureUsage::COPY_SRC == 0x01, "COPY_SRC in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::COPY_DST == 0x02, "COPY_DST in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::TEXTURE_BINDING == 0x04, "TEXTURE_BINDING in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::STORAGE_BINDING == 0x08, "STORAGE_BINDING in GPUTextureUsage does not match value from IDL");
static_assert(GPUTextureUsage::RENDER_ATTACHMENT == 0x10, "RENDER_ATTACHMENT in GPUTextureUsage does not match value from IDL");

template<> const ClassInfo JSGPUTextureUsageDOMConstructor::s_info = { "GPUTextureUsage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUTextureUsageDOMConstructor) };

template<> JSValue JSGPUTextureUsageDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.objectPrototype();
}

template<> void JSGPUTextureUsageDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
    reifyStaticProperties(vm, JSGPUTextureUsage::info(), JSGPUTextureUsageConstructorTableValues, *this);
    UNUSED_PARAM(globalObject);
}

const ClassInfo JSGPUTextureUsage::s_info = { "GPUTextureUsage"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSGPUTextureUsage) };

JSGPUTextureUsage::JSGPUTextureUsage(Structure* structure, JSDOMGlobalObject& globalObject)
    : JSDOMObject(structure, globalObject) { }

static_assert(!std::is_base_of<ActiveDOMObject, GPUTextureUsage>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSValue JSGPUTextureUsage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSGPUTextureUsageDOMConstructor, DOMConstructorID::GPUTextureUsage>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSGPUTextureUsage::destroy(JSC::JSCell* cell)
{
    JSGPUTextureUsage* thisObject = static_cast<JSGPUTextureUsage*>(cell);
    thisObject->JSGPUTextureUsage::~JSGPUTextureUsage();
}

JSC::GCClient::IsoSubspace* JSGPUTextureUsage::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSGPUTextureUsage, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForGPUTextureUsage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForGPUTextureUsage = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForGPUTextureUsage.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForGPUTextureUsage = std::forward<decltype(space)>(space); }
    );
}


}
